#!/bin/bash
#set -x

if [ "$(uname)" == "Darwin" ]; then
    # Do something under Mac OS X platform
    cd src
    FILELIST=`find -E . -regex '.+\.(s?css|woff?|eot|ttf|svg)$'`
    cd ../dist
    REMOVELIST=`find -E . -regex '.+\.(s?css|woff?|eot|ttf|svg)$'`
    cd ..
elif [ "$(expr substr $(uname -s) 1 5)" == "Linux" ]; then
    # Do something under GNU/Linux platform
    cd src
    FILELIST=`find ./ -regex '.+\.\(s?css\|woff?\|eot\|ttf\|svg\)$'`
    cd ../dist
    REMOVELIST=`find ./ -regex '.+\.\(s?css\|woff?\|eot\|ttf\|svg\)$'`
    cd ..
fi

if [ -d dist ]; then
	for i in $REMOVELIST; do
	 rm dist/$i
	done
else
	mkdir dist
fi

for i in $FILELIST; do
 #cp --parents $i ../dist;
 if [ ! -d dist/`dirname $i` ]; then
 	mkdir -p dist/`dirname $i`
 fi
 cp -v src/$i dist/`dirname $i`;
done

#exit 0
