/// <reference types="react" />
import * as React from "react";
import "./alert.scss";
export declare type Props = {
    title: string;
    msg: string[];
    proceedLabel?: string;
    proceedCallback: any;
    dismissLabel?: string;
    dismissCallback: any;
    bsStyle?: string;
};
export declare const buildAlert: (_title?: string, _msg?: string[], _proceedCallback?: Function, proceedLabel?: string, _dismissCallback?: Function, dismissLabel?: string) => {
    title: string;
    msg: string[];
    proceedCallback: Function;
    proceedLabel: string;
    dismissCallback: Function;
    dismissLabel: string;
};
export declare const Alert: (p: Props) => JSX.Element;
export default Alert;
export declare type AlertedState = {
    alert?: Props;
};
export declare type AlertedProps = {
    alert?: Props;
    displayAlert: Function;
};
export declare class Alerted extends React.Component<any, AlertedState> {
    constructor(p: any, context: any);
    static childContextTypes: {
        displayAlert: React.Validator<any>;
    };
    getChildContext(): {
        displayAlert: (_title?: string, _msg?: string[], proceedCallback?: Function, proceedLabel?: string, dismissCallback?: Function, dismissLabel?: string) => void;
    };
    displayWarns(_title?: string, _msg?: string[], proceedCallback?: Function, proceedLabel?: string, dismissCallback?: Function, dismissLabel?: string): void;
    render(): JSX.Element;
}
