/// <reference types="react" />
import * as React from "react";
import { MentionProps } from "./mentionfield";
import { Props as FieldProps } from "./field";
import '../../node_modules/react-quill/dist/quill.snow.css';
/** TS cannot enumerate strings, for now.  */
export declare type Language = 'en' | 'fr' | 'es' | 'zh' | 'ru' | 'ar';
export declare const defaultLanguage: Language;
/** TS cannot index by enum or string literal type, for now.  */
export interface Multilingual {
    en: string;
    [index: string]: string;
}
export declare const multilangSort: (a: Multilingual, b: Multilingual, order: "desc" | "asc", lang?: Language) => number;
export declare const buildMultilingual: () => Multilingual;
import "./multilangfield.scss";
export declare type Type = "text" | "textarea" | "html";
export declare type Props = FieldProps & MentionProps & {
    disabled?: boolean;
    type?: Type;
    value: Multilingual;
    onChange: (val: string) => void;
    className?: string;
};
export interface State {
    nextLang?: string;
    uid: string;
}
export default class MultiValue extends React.Component<Props, State> {
    constructor(props: any);
    initialState(): State;
    onValueChange(key: string, e: any): void;
    onLanguageSelect(lang: any): void;
    onRemove(e: any): void;
    onAdd(e: any): void;
    nextLangs(): string[];
    currentLangs(): string[];
    nextLang(): string;
    render(): JSX.Element;
}
