/// <reference types="react" />
import * as React from "react";
import { Props as FieldProps } from "./field";
import { MentionProps } from "./mentionfield";
export declare type Props = MentionProps & FieldProps & {
    value: string;
    onChange: (val) => void;
    placeholder?: string;
    disabled?: boolean;
    type?: 'text' | 'email' | 'password' | 'file' | 'number' | 'color';
    componentClass?: 'textarea' | 'select' | 'multiple';
    icon?: string;
};
export declare type State = {
    openColor: boolean;
};
declare class TextField extends React.Component<Props, State> {
    constructor(p: Props);
    colourIsLight(r: any, g: any, b: any): boolean;
    componentToHex(c: any): any;
    rgbToHex(r: any, g: any, b: any): string;
    hexToRgb(hex: any): {
        r: number;
        g: number;
        b: number;
    };
    render(): JSX.Element;
}
export default TextField;
