/// <reference types="react" />
import * as React from "react";
import "./worksheet.scss";
export declare type BackButtonProp = {
    text: string;
    callback: () => any;
};
export declare type Props = {
    title: string;
    children?: any[];
    className?: string;
    loading?: boolean;
    onWaitCancel?: any;
    backButton?: BackButtonProp[];
    subtitle?: string;
    log?: string;
    icon?: string;
    subpage?: string;
};
export declare type State = {
    fixed: boolean;
};
declare class Sheet extends React.Component<Props, State> {
    constructor(props: Props);
    onEnter: () => void;
    onLeave: () => void;
    render(): JSX.Element;
}
export default Sheet;
export declare type ButtonProps = {
    role: string;
    name: string;
    disabled?: boolean;
    onClick: any;
    text?: string;
    iconLeft?: true;
    error?: boolean;
    errorMessage?: string;
    errorNumber?: string;
};
export declare const BarButton: (p: ButtonProps) => JSX.Element;
export declare type ButtonGroupProps = {
    children?: any;
    role?: string;
};
export declare const BarButtonsGroup: (p: ButtonGroupProps) => JSX.Element;
export declare type ItemLightPropProps = {
    label?: string;
    icon?: string;
    children?: any;
    role?: string;
    onClick?: any;
    btnStyle?: string;
    tooltip?: string;
};
export declare const ItemLightProp: (p: ItemLightPropProps) => JSX.Element;
